﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Http.Headers;
using System.Text;
using System.Web;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Http.Features;
using Microsoft.AspNetCore.Mvc;
using Microsoft.WindowsAzure.Storage;
using Microsoft.WindowsAzure.Storage.Auth;
using Microsoft.WindowsAzure.Storage.Blob;

namespace BlazorApp1.Data
{
    [Route("api/[controller]")]
    [ApiController]


    public class SampleDataController : ControllerBase
    {

        private IHostingEnvironment hostingEnv;

        [HttpPost("[action]")]
        public async Task Save(IList<IFormFile> UploadFiles)
        {

            var ContainerName = Response.HttpContext.Request.Headers["container"].ToString();
            try
            {
                if (false)
                {
                    throw new InvalidOperationException("Max allowed files erros");
                }
                else
                {
                    foreach (var file in UploadFiles)
                    {

                        const string accountName = "***"; // Provide your accountName
                        const string key = "***"; // Provide your account key

                        var storageAccount = new CloudStorageAccount(new StorageCredentials(accountName, key), true);

                        var blobClient = storageAccount.CreateCloudBlobClient();
                        var container = blobClient.GetContainerReference("filo"); // Provide your container name
                        await container.CreateIfNotExistsAsync();
                        await container.SetPermissionsAsync(new BlobContainerPermissions()
                        {
                            PublicAccess = BlobContainerPublicAccessType.Blob
                        });

                        var blob = container.GetBlockBlobReference(file.FileName);
                        using (var stream = file.OpenReadStream())
                        {
                            await blob.UploadFromStreamAsync(stream);
                        }

                        var filename = hostingEnv.ContentRootPath + $@"\{file.FileName}";
                        if (System.IO.File.Exists(filename))
                        {
                            System.IO.File.Delete(filename);
                        }


                    }
                }
            }
            catch (Exception e)
            {
                Response.Clear();
                Response.StatusCode = 400;
                Response.HttpContext.Features.Get<IHttpResponseFeature>().ReasonPhrase = "File failed to upload";
                Response.HttpContext.Features.Get<IHttpResponseFeature>().ReasonPhrase = e.Message;
                Response.Headers.Add("ID", "Maximum Uploaded files reached");
            }
        }
    }
}
